@use 'sass:color';
@import "https://fonts.googleapis.com/css2?family=Open+Sans:ital,wght@0,300;0,400;0,600;0,700;1,400&display=swap";

html {
  font-family: 'Open Sans', sans-serif;
  --text-primary-color: hsl(0, 0%, 10%);
  --text-secondary-color: #333333;
  --text-accent-color: blue;

  --border-secondary-color: #aaaaaa;
  --border-tertiary-color: #cccccc;
  --border-accent-color: #3e4aef;

  --shadow-color: hsla(0, 0%, 0%, 0.2);

  --background-color: #ffffff;
  --background-secondary-color: hsla(0, 0%, 0%, 3%);
  --background-accent-color: #333333;

  --border-radius: 0.3em;
}


// https://css-tricks.com/dark-modes-with-css/
@media (prefers-color-scheme: dark) {
  // html {
  //   --background-color: red;
  // }
}
input {
  border: unset;
}
textarea {
  border: unset;
}
select {
  appearance: none;
  background-color: unset;
  border: unset;
}

@mixin button-like($color: white, $amnt: 0.15) {
  user-select: none;
  cursor: pointer;

  background-color: $color;

  &:hover {
    background-color: color.adjust($color, $blackness: 100% * $amnt);
  }
  &:active {
    background-color: color.adjust($color, $blackness: 100% * (1 - (1-$amnt) * (1-$amnt)));
  }
}

.button {
  box-sizing: border-box;
  border: 1px solid var(--border-secondary-color);
  border-radius: var(--border-radius);
  padding: 0.1em 0.2em;
  background-color: var(--background-color);
  text-align: center;

  @include button-like;
}


@mixin page-header($is_root: false) {
  font-size: 190%;
  font-weight: 600;
  padding: 0.3em 0.5em;
  box-shadow: 0 0.05em 0.1em var(--shadow-color);

  z-index: 20;

  display: grid;
  grid-template-areas: "root title space other" ;
  grid-template-columns: max-content max-content 1fr max-content;

  & > .root {
    align-self: center;
    font-size: 110%;
    padding-left: 2em;
    padding-right: 0.5em;
    color: inherit;
    text-decoration: none;
    grid-area: root;
    border-radius: var(--border-radius);
    position: relative;
    @include button-like;
    &::before {
      position: absolute;
      content: "";
      left: 0.3em;
      top: 50%;
      height: 1.2em;
      width: 1.2em;
      background: no-repeat center/cover url("./assets/plain/favicon-64x64.png");
      border-radius: var(--border-radius);
      transform: translateY(-50%);
    }
    @if (not $is_root) {
      &::after {
        position: absolute;
        right: -1em;
        top: 50%;
        height: 1em;
        width: 1em;

        content: "";
        border-right: 0.3em solid var(--text-secondary-color);
        border-bottom: 0.3em solid var(--text-secondary-color);
        border-top-right-radius: var(--border-radius);
        border-bottom-left-radius: var(--border-radius);
        transform:
          scale(40%, 60%)
          translateX(1.1em)
          translateY(-1.05em)
          rotate(-45deg)
          ;
      }
    }
  }
  & > .title {
    align-self: center;
    grid-area: title;
    font-size: 110%;

    margin-left: 2em;
  }
  & > .space {
    grid-area: space;
  }
  & > .other {
    grid-area: other;
    font-size: 80%;
    align-self: center;
  }
}

// $imagedir: 
//
// // By webmaster pf https://stackoverflow.com/questions/49133632/sass-mixin-to-use-svg-as-background-and-change-color#49140696
// @mixin backgroundSVGColor($filename, $color) {
//   background-image: url('data:image/svg+xml,%3Csvg xmlns="http://www.w3.org/2000/svg" fill="url('#{$imagedir}#{$filename}')" color='#{$color}');
// }
